package com.lenovo.plm.isg.dms.customer.refreshdata;

import com.lenovo.plm.isg.common.integration.DBOperationUtil;
import com.lenovo.plm.isg.common.util.ExcelHandler;
import com.lenovo.plm.isg.common.wcutil.DocUtil;
import com.lenovo.plm.isg.common.wcutil.MBAUtil;
import com.lenovo.plm.isg.custommodel.component.CMLoadSheetHelper;
import com.lenovo.plm.isg.dms.customer.refreshdata.FSChangeDataSql;
import com.lenovo.plm.isg.dms.customer.refreshdata.bean.FactSheetImportBean;
import com.lenovo.plm.isg.dms.customer.util.CustomerDMUtil;
import com.ptc.netmarkets.workflow.NmWorkflowHelper;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.concurrent.Executors;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.TimeUnit;
import javax.xml.parsers.ParserConfigurationException;
import org.apache.commons.collections4.ListUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.xml.sax.SAXException;
import wt.auth.AuthenticationServer;
import wt.content.ApplicationData;
import wt.content.ContentHelper;
import wt.content.ContentRoleType;
import wt.content.ContentServerHelper;
import wt.doc.WTDocument;
import wt.fc.QueryResult;
import wt.httpgw.GatewayAuthenticator;
import wt.inf.container.WTContainerRef;
import wt.method.RemoteAccess;
import wt.method.RemoteMethodServer;
import wt.pom.PersistentObjectManager;
import wt.pom.Transaction;
import wt.session.SessionHelper;
import wt.session.SessionThread;
import wt.type.ClientTypedUtility;
import wt.util.WTException;
import wt.vc.VersionControlHelper;
import wt.workflow.engine.WfProcess;
import wt.workflow.engine.WfState;

public class FactSheetDataChange implements Runnable, RemoteAccess {

   private static Logger LOGGER = LoggerFactory.getLogger(FactSheetDataChange.class.getName());
   List splitBeanList = null;
   List successList = null;
   List failureList = null;
   List noChangeList = null;


   public FactSheetDataChange(List splitBeanList, List successList, List failureList, List noChangeList) {
      this.splitBeanList = splitBeanList;
      this.successList = successList;
      this.failureList = failureList;
      this.noChangeList = noChangeList;
   }

   public static void main(String[] args) throws Exception {
      RemoteMethodServer rms = RemoteMethodServer.getDefault();
      GatewayAuthenticator auth = new GatewayAuthenticator();
      auth.setRemoteUser(SessionHelper.manager.getAdministrator().getName());
      rms.setAuthenticator(auth);
      Class[] acls = new Class[]{String.class, String.class};
      Object[] aobj = new Object[]{"-----change begin------", "-----change end--------"};
      rms.invoke("changeFSInfo", FactSheetDataChange.class.getName(), (Object)null, acls, aobj);
   }

   public static void changeFSInfo(String begin, String end) throws Exception {
      LOGGER.error(begin);
      if(!CustomerDMUtil.checkTableExist(FSChangeDataSql.TBALE_NAME)) {
         DBOperationUtil.executeNonQuery(FSChangeDataSql.CREATE_TABLE_SQL);
      }

      List successList = DBOperationUtil.commonQueryAll(FSChangeDataSql.SELECT_SUCESS_SQL, new String[0]);
      List failureList = DBOperationUtil.commonQueryAll(FSChangeDataSql.SELECT_FAILURE_SQL, new String[0]);
      List noChangeList = DBOperationUtil.commonQueryAll(FSChangeDataSql.SELECT_NOCHANGE_SQL, new String[0]);
      List beanList = queryImportDataList();
      LOGGER.error("beanList===>" + beanList.size());
      List splitList = ListUtils.partition(beanList, 1000);
      ScheduledExecutorService schedule = Executors.newScheduledThreadPool(8);
      Iterator var9 = splitList.iterator();

      while(var9.hasNext()) {
         List e = (List)var9.next();
         schedule.schedule(new SessionThread(new FactSheetDataChange(e, successList, failureList, noChangeList)), 1L, TimeUnit.SECONDS);
      }

      schedule.shutdown();

      while(!schedule.isTerminated()) {
         try {
            Thread.sleep(200L);
         } catch (InterruptedException var10) {
            var10.printStackTrace();
            break;
         }
      }

      LOGGER.error(end);
   }

   public static List queryImportDataList() throws Exception {
      ArrayList beanList = new ArrayList();
      List attDatalList = queryAttachements();
      Iterator var3 = attDatalList.iterator();

      while(var3.hasNext()) {
         ApplicationData secondaryData = (ApplicationData)var3.next();
         InputStream inputstream = ContentServerHelper.service.findContentStream(secondaryData);
         ExcelHandler handler = new ExcelHandler(inputstream);
         int rows = handler.getLastRowNum() + 1;
         int i = 2;

         while(true) {
            if(i < rows) {
               String fsNumber = handler.getValue(i, 0);
               if(!"".equals(fsNumber)) {
                  String country = handler.getValue(i, 1);
                  String customerID = handler.getValue(i, 2);
                  String source = handler.getValue(i, 3);
                  String cmType = handler.getValue(i, 4);
                  String customerIDCountry = handler.getValue(i, 5);
                  String sensitiveFlag = handler.getValue(i, 6);
                  String alternativeID = handler.getValue(i, 7);
                  FactSheetImportBean bean = new FactSheetImportBean();
                  bean.setFactSheetNumber(fsNumber);
                  bean.setCountry(country);
                  bean.setCustomerID(customerID);
                  bean.setSource(source);
                  bean.setCmType(cmType);
                  bean.setCustomerIDCountry(customerIDCountry);
                  bean.setSensitiveFlag(sensitiveFlag);
                  bean.setAlternativeID(alternativeID);
                  beanList.add(bean);
                  ++i;
                  continue;
               }
            }

            inputstream.close();
            break;
         }
      }

      return beanList;
   }

   public static List queryAttachements() throws Exception {
      ArrayList attDatalList = new ArrayList();
      WTDocument fsInfo = DocUtil.getLatestDocumentByNumber("FACTSHEET_DATA");
      QueryResult qr = ContentHelper.service.getContentsByRole(fsInfo, ContentRoleType.SECONDARY);

      while(qr.hasMoreElements()) {
         ApplicationData oAppData = (ApplicationData)qr.nextElement();
         attDatalList.add(oAppData);
      }

      return attDatalList;
   }

   public void run() {
      try {
         AuthenticationServer.setUserName(SessionHelper.manager.getAdministrator().getName());
         this.execute();
      } catch (Exception var2) {
         var2.printStackTrace();
      }

   }

   public void execute() throws WTException, ParserConfigurationException, SAXException, IOException {
      ArrayList insertList = new ArrayList();
      ArrayList updateList = new ArrayList();
      Iterator var4 = this.splitBeanList.iterator();

      while(var4.hasNext()) {
         FactSheetImportBean bean = (FactSheetImportBean)var4.next();
         String fsNumber = bean.getFactSheetNumber();
         String sensitiveFlag = bean.getSensitiveFlag();
         String customerIDCountry = bean.getCustomerIDCountry();
         String alternativeID = bean.getAlternativeID();
         WTDocument fsDoc = DocUtil.getLatestDocumentByNumber(fsNumber);
         if(fsDoc != null) {
            LOGGER.error("successList==>" + this.successList);
            if(!this.successList.contains(fsNumber)) {
               String customerName = CustomerDMUtil.notNull(MBAUtil.getObjectValue(fsDoc, "com.lenovo.EndCustPartnerName"));
               String customerAddress = CustomerDMUtil.notNull(MBAUtil.getObjectValue(fsDoc, "com.lenovo.EndCustomerParterAddress"));
               LOGGER.error("failureList==>" + this.failureList);
               LOGGER.error("noChangeList==>" + this.noChangeList);
               Map resultMap = this.checkandChangeResult(fsNumber, sensitiveFlag, customerIDCountry, alternativeID);
               LOGGER.error("fsNumber==>" + fsNumber + ";;;;;resultMap====>" + resultMap);
               if(this.failureList.contains(fsNumber)) {
                  updateList.add(new String[]{customerIDCountry, sensitiveFlag, alternativeID, (String)resultMap.get("CHANGE_STATUS"), (String)resultMap.get("ERROR_MESSAGE"), fsNumber});
               } else if(this.noChangeList.contains(fsNumber)) {
                  String changeStatus = (String)resultMap.get("CHANGE_STATUS");
                  if(!"NOCHANGE".equals(changeStatus)) {
                     updateList.add(new String[]{customerIDCountry, sensitiveFlag, alternativeID, changeStatus, (String)resultMap.get("ERROR_MESSAGE"), fsNumber});
                  }
               } else {
                  insertList.add(new String[]{bean.getFactSheetNumber(), bean.getCountry(), bean.getCustomerID(), customerName, customerAddress, bean.getSource(), bean.getCmType(), bean.getCustomerIDCountry(), bean.getSensitiveFlag(), bean.getAlternativeID(), (String)resultMap.get("CHANGE_STATUS"), (String)resultMap.get("ERROR_MESSAGE")});
               }
            }
         }
      }

      DBOperationUtil.executeNonQueryBatch(FSChangeDataSql.INSERT_DATA_SQL, insertList);
      DBOperationUtil.executeNonQueryBatch(FSChangeDataSql.UPDATE_DATA_SQL, updateList);
   }

   public Map checkandChangeResult(String fsNumber, String sensitiveFlag, String customerIDCountry, String alternativeID) {
      Object resultMap = new HashMap();
      if("Yes".equalsIgnoreCase(sensitiveFlag) && "".equals(alternativeID)) {
         ((Map)resultMap).put("CHANGE_STATUS", "NOCHANGE");
         ((Map)resultMap).put("ERROR_MESSAGE", "Sensitive Flag is Yes but alternative ID is blank.");
         return (Map)resultMap;
      } else if("".equals(sensitiveFlag) && ("US".equalsIgnoreCase(customerIDCountry) || "CA".equalsIgnoreCase(customerIDCountry))) {
         ((Map)resultMap).put("CHANGE_STATUS", "NOCHANGE");
         ((Map)resultMap).put("ERROR_MESSAGE", "Country is US or CA but ensitive Flag is blank.");
         return (Map)resultMap;
      } else if("".equals(sensitiveFlag)) {
         ((Map)resultMap).put("CHANGE_STATUS", "NOCHANGE");
         ((Map)resultMap).put("ERROR_MESSAGE", "Sensitive Flag is blank no need to change.");
         return (Map)resultMap;
      } else {
         String errorMessage;
         try {
            WTDocument e = DocUtil.getLatestDocumentByNumber(fsNumber);
            if(e != null) {
               errorMessage = e.getLifeCycleState().toString();
               if(!"COMPLETED".equalsIgnoreCase(errorMessage)) {
                  ((Map)resultMap).put("CHANGE_STATUS", "NOCHANGE");
                  ((Map)resultMap).put("ERROR_MESSAGE", "Fact sheet state isn\'t Completed.");
                  return (Map)resultMap;
               }

               resultMap = this.changeResult(e, sensitiveFlag, customerIDCountry, alternativeID);
            }
         } catch (Exception var8) {
            LOGGER.error(var8.getLocalizedMessage(), var8);
            errorMessage = var8.getLocalizedMessage();
            ((Map)resultMap).put("CHANGE_STATUS", "FAILURE");
            ((Map)resultMap).put("ERROR_MESSAGE", errorMessage + ".");
         }

         return (Map)resultMap;
      }
   }

   private boolean hasOpenRunningProcess(WTDocument fsDoc) throws WTException {
      boolean isRunning = false;
      QueryResult qr = NmWorkflowHelper.service.getAssociatedProcesses(fsDoc, WfState.OPEN_RUNNING, (WTContainerRef)null);

      while(qr.hasMoreElements()) {
         WfProcess wfprocess = (WfProcess)qr.nextElement();
         String workflowName = wfprocess.getTemplate().getName();
         if(workflowName.startsWith("Lenovo_sbids")) {
            isRunning = true;
         }
      }

      return isRunning;
   }

   public Map changeResult(WTDocument fsDoc, String sensitiveFlag, String customerIDCountry, String alternativeID) throws Exception {
      HashMap resultMap = new HashMap();
      boolean defineTR = true;
      Transaction transaction = null;

      try {
         if(!PersistentObjectManager.getTransactionManager().isTransactionActive()) {
            transaction = new Transaction();
            transaction.start();
         } else {
            defineTR = false;
            transaction = Transaction.getCurrentTransaction();
         }

         if("Yes".equalsIgnoreCase(sensitiveFlag)) {
            String e = ClientTypedUtility.getExternalTypeIdentifier(fsDoc);
            if(e.contains("com.lenovo.CustomFactsheet")) {
               String iterationDoc = fsDoc.getName();
               if(!iterationDoc.endsWith(alternativeID)) {
                  String newName = iterationDoc.substring(0, iterationDoc.lastIndexOf("_") + 1) + alternativeID;
                  CMLoadSheetHelper helper = new CMLoadSheetHelper();
                  helper.renameName(fsDoc, newName);
               }
            }
         }

         WTDocument iterationDoc1;
         for(QueryResult e1 = VersionControlHelper.service.allIterationsFrom(fsDoc); e1.hasMoreElements(); this.updatePrimary(iterationDoc1, sensitiveFlag, customerIDCountry, alternativeID)) {
            iterationDoc1 = (WTDocument)e1.nextElement();
            if(!"".equals(sensitiveFlag)) {
               MBAUtil.setObjectValue(iterationDoc1, "com.lenovo.EndCustomerParterAddress", "");
               MBAUtil.setObjectValue(iterationDoc1, "com.lenovo.EndCustSensitiveFlag", sensitiveFlag);
            }

            if("Yes".equalsIgnoreCase(sensitiveFlag)) {
               MBAUtil.setObjectValue(iterationDoc1, "com.lenovo.EndCustPartnerName", "");
               if(!"".equals(alternativeID)) {
                  MBAUtil.setObjectValue(iterationDoc1, "com.lenovo.EndCustPartnerID", alternativeID);
               }
            }
         }

         if(defineTR) {
            transaction.commit();
         }

         transaction = null;
         resultMap.put("CHANGE_STATUS", "SUCCESS");
         resultMap.put("ERROR_MESSAGE", "");
         return resultMap;
      } catch (Exception var15) {
         throw new Exception(var15);
      } finally {
         if(transaction != null) {
            transaction.rollback();
         }

      }
   }

   public void updatePrimary(WTDocument iterationDoc, String sensitiveFlag, String customerIDCountry, String alternativeID) throws Exception {
      String xmlPath = CustomerDMUtil.downXMLFile(iterationDoc);
      String xmlNewPath = CustomerDMUtil.changeXML(iterationDoc, xmlPath, sensitiveFlag, customerIDCountry, alternativeID);
      File file = new File(xmlNewPath);
      if(file != null && file.isFile()) {
         CustomerDMUtil.setApplicationData(iterationDoc, xmlNewPath);
         file.delete();
         (new File(xmlPath)).delete();
      }

   }
}
